#define N_const 25
#define M_const 7

unsigned TT800(void) {
   const unsigned A[2] = { 0, 0x8ebfd028 };

   static unsigned y[25];
   static int index = N_const+1;

   if (index >= N_const) {
     int k;
     if (index > N_const) {
        unsigned r = 9, s = 3402;
        for (k=0 ; k<N_const ; ++k) {
          r = 509845221 * r + 3;
          s *= s + 1;
          y[k] = s + (r >> 10);
        }
     }
     for (k=0 ; k<N_const-M_const ; ++k)
        y[k] = y[k+M_const] ^ (y[k] >> 1) ^ A[y[k] & 1];
     for (; k<N_const ; ++k)
        y[k] = y[k+(M_const-N_const)] ^ (y[k] >> 1) ^ A[y[k] & 1];
     index = 0;
   }

   unsigned e = y[index++];
   e ^= (e << 7) & 0x2b5b2500;
   e ^= (e << 15) & 0xdb8b0000;
   e ^= (e >> 16);
   return e;
 }
